import time
import sys
import serial


print "INICIALIZUJI KOMUNIKACI S PRISTROJI"
###############################################
#zacatek inicializace komunikace s teplotnim kontrolerem Lakeshore 325

NoSerPort=6  # COM7
TeplotniKontrolerSer=serial.Serial(NoSerPort) 
print "Spojuji Lakeshore 325 na portu RS232  cislo ", NoSerPort+1
TeplotniKontrolerSer.baudrate=9600
TeplotniKontrolerSer.parity = serial.PARITY_ODD
TeplotniKontrolerSer.bytesize = serial.SEVENBITS
TeplotniKontrolerSer.stopbits = serial.STOPBITS_ONE
TeplotniKontrolerSer.xonxoff = 0	

# send SCPI command
def TeplotniKontroler(msg):
  global TeplotniKontrolerSer
  TeplotniKontrolerSer.write(msg+"\r\n")
  return

def SetPoint(T):
	Odeslat="SETP 1,"+str(T)+"[term]"
	TeplotniKontroler(Odeslat)
	return

def HeaterOn():
	Odeslat="RANGE 1,2[term]"
	TeplotniKontroler(Odeslat)
	time.sleep(0.2)
	return

  
# test spojeni
TeplotniKontroler("*IDN?")
print "odpoved na *IDN?:", TeplotniKontrolerSer.readline()
#raw_input('press Enter...')

def Teplota():
  TeplotniKontroler("KRDG?")
  T=TeplotniKontrolerSer.readline()
  Tf=float(T)
  print "Teplota vzorku:", Tf
  return Tf

#konec inicializace komunikace s teplotnim kontrolerem Lakeshore 325
#############################################################


##########################################
#- inicializace komunikace se zdrojem proudu Keithely 6220
NoSerPort=2  # COM3
ZdrojProuduSer=serial.Serial(NoSerPort) 
print "Spojuji Keithely 6220 na portu RS232  cislo ", NoSerPort+1
ZdrojProuduSer.baudrate=19200
ZdrojProuduSer.parity = serial.PARITY_NONE
ZdrojProuduSer.bytesize = serial.EIGHTBITS
ZdrojProuduSer.stopbits = serial.STOPBITS_ONE
ZdrojProuduSer.xonxoff = 0	

# definice SCPI prikazu 
def ZdrojProudu(msg):
  global ZdrojProuduSer
  ZdrojProuduSer.write(msg+"\r\n")
  return

# which instrument?
ZdrojProudu("*IDN?")
print "odpoved na *IDN?:", ZdrojProuduSer.readline()
#- konec inicializace komunikace se zdrojem proudu Keithely 6220
##########################################

##########################################
#- inicializace komunikace s data acuisition unit (DAU) Agilent 34970A
NoDAUSerPort=5  # COM6
print "Spojuji Agilent 34970A data acquisition unit na portu RS232  ", NoDAUSerPort+1
DAUSer=serial.Serial(NoDAUSerPort) # COM6
DAUSer.baudrate=4800
DAUSer.parity = serial.PARITY_NONE
DAUSer.bytesize = serial.EIGHTBITS
DAUSer.stopbits = 1
DAUSer.xonxoff = 0
  
# definice SCPI commandu 
def DAU(msg):
  global DAUSer
  DAUSer.write(msg+"\r\n")
  return
  
# which instrument?
DAU("*IDN?")
print "odpoved na *IDN?:", DAUSer.readline()
# configure Agilent for the measurement
DAU("SYST:REM")
DAU("*RST")
time.sleep(1)  

#- konec inicializace komunikace s Agilent 34970A
##########################################



##############################################
# inicializace komunikace s zdrojem proudu pro magnet Agilent N5769A  
import visa
AgilentZdrojMagnet = visa.instrument("USB0::0x0957::0x0807::N5769A-US12M4360G::0::INSTR")
print "dotaz na *IDN? :", AgilentZdrojMagnet.ask("*IDN?")

def MagnetProud(I):
  #Set current level
  AgilentZdrojMagnet.write("CURR " + str(I))
  return

def MagnetNapeti(V):
  #Set voltage level
  AgilentZdrojMagnet.write("VOLT " + str(V))
  return

def MagnetOn():
  #Set current level
  AgilentZdrojMagnet.write("OUTP ON")
  return

def MagnetOff():
  #Set current level
  AgilentZdrojMagnet.write("OUTP OFF")
  return
  
# konec inicializace komunikace s zdrojem proudu pro magnet Agilent N5769A  
##############################################


##############################################
#inicializace komunikace s digitalni kartou pro relatka Velleman
#import pyk8055  #verbose verze
import pyk8055_nv  #non verbose verze
#Requires Python 2.7, and 32 bit windows
import time
#dev = pyk8055.device()
dev = pyk8055_nv.device()

#urcuje casovou mezeru mezi vypinani relatek, kdyz je nula, tak to nefunguje, muze se zrychlit na 0.5s
BTimeDelay=1


#konec inicializace komunikace s digitalni kartou pro relatka Velleman
###########################################################

print "KONEC INICIALIZACE KOMUNIKACE S PRISTROJI"
print
