#Program na  mereni Hallova napeti pro ruzne hodnoty magnetickeho pole, tedy pro stestovani podminky slabeho pole
#pouziva zdroj proudu pro halla Keithely 6220
#pouziva Agilent data acquisition unit 34970A
#pouziva zdroj proudu pro magnet AgilentN5769A
import time
import sys
import serial







# vsechny zakladni inizializace komunikace s pristroji a zakladni rutinky pro komunikaci, uzitecne k nahlednuti
from HallPristrojeInicializace import *

#prikazy pro zapnuti pole plus, minus a vypnuti pole. Vypina u toho zdroj proud pro magnet.
def BPlusOn():
  dev.digital_on(1) # Turns on digital channel 1
  print "Magneticke pole Plus zapnuto"
  time.sleep(BTimeDelay)
  dev.digital_off(1) # Turns off digital channel 1
  MagnetOn()
  time.sleep(CasovaProdlevaPole)  # cekani na ustabilizovani Pole
  return 


def BOff():
  MagnetOff()
  time.sleep(BTimeDelay)
  dev.digital_on(2) # Turns on digital channel 2
  print "Magneticke pole vypnuto"
  time.sleep(BTimeDelay)
  dev.digital_off(2) # Turns off digital channel 2
  return 


def BMinusOn():
  dev.digital_on(3) # Turns on digital channel 3
  print "Magneticke pole Minus zapnuto"
  time.sleep(BTimeDelay)
  dev.digital_off(3) # Turns off digital channel 3
  MagnetOn()
  time.sleep(CasovaProdlevaPole)  # cekani na ustabilizovani Pole
  return 


# procedura pro nastaveni proudu vzorkem
def NastavProudHall(Proud):
  #print "CURRent "+str(Proud)
  ZdrojProudu("CURRent "+str(Proud)) # nastav proud
  time.sleep(TimeCurrentDelay)  #chvili pocka na ustabilizovani proudu
  return

# procedura pro zmereni napeti na multiplexru (data acquisition unit)
def ZmerNapeti():
  DAU("INIT")  # perform scan
  time.sleep(2)  # musi byt prodleva, v zavislosti na integracni dobe NPLC
  DAU("DATA:REMOVE? 2")    # read data
  mstr=DAUSer.readline()     # konverze dat
  Ua,Ub=map(float,mstr[:-2:].split(','))
  #print "Namereny string:", mstr
  Ua=Ua*1000 # prepocet na mV
  Ub=Ub*1000 # prepocet na mV
  print 'Napeti Halovo =%8.4f mV  Napeti vodivostni =%8.4f mV' %(Ua,Ub)#global U1
  return Ua,Ub



###########################################################
#hlavni program


#Konfigurace scanu Agilentu Data Acquisition Unit
# channels 105,115 - DC voltage to 5 digits
DAU("CONF:VOLT:DC (@105,115)")
#manual: VOLTage:DC:NPLC {0.02|0.2|1|2|10|20|100|200|MIN|MAX}[,(@<ch_list>)]
#DAU("VOLT:NPLC 10")   #5 digits, to improve put larger number
DAU("VOLT:NPLC 20")   # digits, to improve put larger number
DAU("ROUTE:SCAN (@105,115)")

  


################################
# nastaveni pocatecnich parametru
#jmeno vystupniho souboru
SouborHallJmeno="VystupNapetiHall.dat"
SouborOhmJmeno="VystupNapetiOhm.dat"

dev.digital_all_off()  # vypne vsechny digitalni vystupy, jen hygyena, nevim proc nefunguje
BOff   # vypne zdroj proudu pro magnet a vypne digitalni vystup 2
MagnetNapeti(100)  #nastavi maximalni napeti ve voltech na zdroji pro magnet, max 100V, regulovat se bude proudem


print
print
print "Nastavene parametry:"  
ProudHall =5.0; # v miliamperech
print "Proud vzorkem je ", ProudHall, "mA"
ProudHall = ProudHall /1000

MaxMagnetProudVal=13   # zadani hodnoty proudu pro magnet v amperech, max 15A. 
PocetMagPoli=13

#MagnetProud(MaxMagnetProudVal)  #  
#print "Proud magnetem nastaven na " + str(MaxMagnetProudVal) + "A"

CasovaProdlevaPole=7  # casova prodleva v sekundach kdy se ceka na ustabilizovani mag. pole
print "Casova prodleva pro cekani na stabilitu pole je " + str(CasovaProdlevaPole) + "s"

BOff()  # vypnuti pole, strasne dulezite, mel bych udelat ochranu pred tim, aby se nekomutovalo bez vypnuteho pole

raw_input("stiskni klavesu")
print

PocatecniTeplota=105  #v kelvinech
KonecnaTeplota=360
TeplotaKrok=1
#PocetTeplot=round(KonecnaTeplota-PocatecniTeplota)/TeplotaKrok)
PocetTeplot=50
TimeStabDelay=7	# doba v sekundach na ustabilizaci teploty

TimeCurrentDelay=1  #doba v sekundach co se ceka po nastaveni proudu kvuli stabilizaci

SouborHall = open(SouborHallJmeno,'a')
SouborOhm = open(SouborOhmJmeno,'a')
print >> SouborOhm, "T \t ProudHall \t ProudMagnet \t UOhm1 \t UOhm1kom \t R \t UOhmPolePlus \t UOhmPolePlusKom \t UOhmPoleMinus \t UOhmPoleMinusKom \t Rpole \t MagnetoResistance"
print >> SouborHall, "T \t ProudHall \t ProudMagnet \t UHallPolePlus \t UHallPolePlusKom \t UHallPoleMinus \t UHallPoleMinusKom \t UHall"
SouborHall.close()
SouborOhm.close()


#################################
#Merici cyklus

SetPointT=PocatecniTeplota
SetPoint(SetPointT)
HeaterOn()
#raw_input("teplota nastavena stiskni klavesu")

for x in range(0,PocetMagPoli):
	MagnetProudVal=1.0*MaxMagnetProudVal*(x+1)/PocetMagPoli   # zadani hodnoty proudu pro magnet v amperech, max 15A. 
	MagnetProud(MagnetProudVal)  #  
	print "Proud magnetem nastaven na " + str(MagnetProudVal) + "A"

	SetPoint(SetPointT)
	print "Teplotni Setpoint ="+str(SetPointT)+" K"
	print "Cekam " + str(TimeStabDelay) + "s na ustabilizovani teploty"
	time.sleep(TimeStabDelay)

	Tpred=Teplota()  #zmereni teploty pred merenim

	ZdrojProudu(" OUTPut ON") # sepne proud

	# zmer vodivost bez magnetickeho pole
	
	print "Merim pri nulovem poli"
	NastavProudHall(ProudHall)
	UHall1,UOhm1=ZmerNapeti()
	NastavProudHall(-ProudHall)
	UHall1kom,UOhm1kom=ZmerNapeti()
	#prumer hodnot pri opacnem proudu
	R =(UOhm1-UOhm1kom)/2/(ProudHall*1000)

	#zmer Hallovo napeti kladne pole
	
	print "Merim pri kladnem poli"
	BPlusOn()   # zapne pole plus
	NastavProudHall(ProudHall)
	UHallPolePlus,UOhmPolePlus=ZmerNapeti()
	NastavProudHall(-ProudHall)
	UHallPolePlusKom,UOhmPolePlusKom=ZmerNapeti()

	BOff()  # vypnuti pole, strasne dulezite, mel bych udelat ochranu pred tim, aby se nekomutovalo bez vypnuteho pole

	#zmer Hallovo napeti zaporne pole
	#print "Merim pri zapornem poli"
	BMinusOn()   # zapne pole minus
	NastavProudHall(ProudHall)
	UHallPoleMinus,UOhmPoleMinus=ZmerNapeti()
	NastavProudHall(-ProudHall)
	UHallPoleMinusKom,UOhmPoleMinusKom=ZmerNapeti()

	BOff()  # vypnuti pole, strasne dulezite, mel bych udelat ochranu pred tim, aby se nekomutovalo bez vypnuteho pole

	#zmer Hallovo napeti kladne pole, pro mereni kdyz se teplota kontinuelne meni

		
	Tpo=Teplota()  #zmereni teploty po mereni
	T=(Tpred+Tpo)/2 #prumerna teplota

	print "Teplota pred merenim " + str(Tpred)+ "K, Teplota po mereni " + str(Tpo) + "K prumerna teplota  "  +str(T)

	Rpole=(UOhmPolePlus + UOhmPoleMinus + UOhmPoleMinus + UOhmPoleMinusKom)/4/ProudHall
	MagnetoResistance =(Rpole-R)/R

	UHall = (UHallPolePlus-UHallPolePlusKom-UHallPoleMinus+UHallPoleMinusKom)/4

	#ulozeni do souboru
	SouborHall = open(SouborHallJmeno,'a')
	SouborOhm = open(SouborOhmJmeno,'a')
	print >> SouborOhm, ' %15.5f %15.5f %15.5f %15.5f %15.5f %15.5f %15.5f %15.5f %15.5f %15.5f %15.5f %15.5f' % (T, ProudHall*1000,MagnetProudVal,UOhm1,UOhm1kom,R,UOhmPolePlus,UOhmPolePlusKom,UOhmPoleMinus,UOhmPoleMinusKom,Rpole,MagnetoResistance)
	print >> SouborHall, ' %15.5f %15.5f %15.5f %15.5f %15.5f %15.5f %15.5f %15.5f' % (T, ProudHall*1000,MagnetProudVal,UHallPolePlus,UHallPolePlusKom,UHallPoleMinus,UHallPoleMinusKom,UHall)
	SouborHall.close()
	SouborOhm.close()
	print
	print "Konec mereni jedne teploty"
	
#	SetPointT=SetPointT+TeplotaKrok
	#print "Konec mereni jedne teploty, cekam 10s, mozno prerusit"
	print
	#time.sleep(10)
	

################################
#konec mericiho cyklu


ZdrojProudu(" OUTPut OFF") # vypne proud
#raw_input('proud je vypnuty ')





